// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com

package engine.gameManager;

import engine.loot.WorkOrder;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.DelayQueue;
import java.util.concurrent.atomic.AtomicInteger;

public enum ForgeManager implements Runnable {

    FORGE_MANAGER;

    private final BlockingQueue<WorkOrder> workQueue = new DelayQueue();
    public static final AtomicInteger workOrder = new AtomicInteger(0);

    @Override
    public void run() {

        while (true) {

            try {

                WorkOrder workOrder = workQueue.take();

                // Fulfill workOrder

                for (int i = 0; i < workOrder.slotCount; ++i) {

                    // Create workOrder items; one for each slot
                    // assigned to this workOrder.

                    // if Prefix and suffix are null random roll item
                    // otherwise roll what was asked for

                    workOrder.itemCount = workOrder.itemCount - 1;

                }

                if (workOrder.itemCount == 0) {

                    workOrder.runCompleted = true;

                    //  Remove this workOrder from any slots on vendor

                    continue;
                }

                // Resubmit workOrder

                workOrder.completionTime = System.currentTimeMillis() + 10000;

            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }

    }
}
